/*  -*- Mode: Asm -*-  */
/*
    fixsfsi.S is part of     FPlib V 0.3.0       ported to avr-as
    for copyright and details see readme.fplib

 *------------------------------------------------------------------------------------------
 * data conversion section
 *------------------------------------------------------------------------------------------
 *
 * A = (long)A
 */

#include "gasava.inc"
#include "fplib.inc"

          TEXT_SEG(fplib, __fixsfsi)
          FUNCTION(__fixsfsi)

GLOBAL(__fixsfsi)
GLOBAL(__fixunssfsi)
   BST     rA3,7
   RCALL   _U(__fp_split1)
   LDI     rTI0,0x7F+31
   SUB     rTI0,rA3
   MOV     rA3,rA2
   MOV     rA2,rA1
   MOV     rA1,rA0
   MOV     rA0,rAE
   RJMP    ___fixsfsi_10

 ___fixsfsi_05:
   LSR    rA3
   ROR    rA2
   ROR    rA1
   ROR    rA0
 ___fixsfsi_10:
   DEC    rTI0
   BRPL   ___fixsfsi_05
   BRTC   no_neg
   /* TEXT_SEG(fp_lneg) */
GLOBAL(__fp_lneg)
   COM     rA3
   COM     rA2
   COM     rA1
   NEG     rA0
   SBCI    rA1,0xFF
   SBCI    rA2,0xFF
   SBCI    rA3,0xFF
 no_neg:
   RET

          ENDFUNC


