/*
   Copyright (C) 1999 Marek Michalkiewicz <marekm@linux.org.pl>

   Permission to use, copy, modify, and distribute this software and
   its documentation for any purpose and without fee is hereby granted,
   without any conditions or restrictions.  This software is provided
   "as is" without express or implied warranty.
 */

#include <string.h>

char *
strncpy(char *dest, const char *src, size_t n)
{
	register char *tmp = dest;

	if (n) {
#if 1
		while ((*tmp++ = *src++) != '\0') {
			if (--n == 0)
				goto done;
		}
		do {
			*tmp++ = '\0';
		} while (--n);
done:
#else
		while (((*tmp++ = *src++) != '\0') && --n)
			;
		if (n) {
			do {
				*tmp++ = '\0';
			} while (--n);
		}
#endif
	}
	return dest;
}

